!
!                      Yeppp! library implementation
!
! This file is part of Yeppp! library and licensed under 2-clause BSD license.
! See library/LICENSE.txt for details.
!
!
module yepLibrary
    interface
        integer(C_INT) function yepLibrary_Init() BIND(C, name='yepLibrary_Init')
            use ISO_C_BINDING, only: C_INT
        end function yepLibrary_Init
        integer(C_INT) function yepLibrary_Release() BIND(C, name='yepLibrary_Release')
            use ISO_C_BINDING, only: C_INT
        end function yepLibrary_Release
        integer(C_INT) function yepLibrary_GetTimerTicks(t) BIND(C, name='yepLibrary_GetTimerTicks')
            use ISO_C_BINDING, only: C_INT, C_INT64_T
            INTEGER(C_INT64_T), intent(OUT) :: t
        end function yepLibrary_GetTimerTicks
        integer(C_INT) function yepLibrary_GetTimerFrequency(f) BIND(C, name='yepLibrary_GetTimerFrequency')
            use ISO_C_BINDING, only: C_INT, C_INT64_T
            INTEGER(C_INT64_T), intent(OUT) :: f
        end function yepLibrary_GetTimerFrequency
        integer(C_INT) function yepLibrary_GetTimerAccuracy(f) BIND(C, name='yepLibrary_GetTimerAccuracy')
            use ISO_C_BINDING, only: C_INT, C_INT64_T
            INTEGER(C_INT64_T), intent(OUT) :: f
        end function yepLibrary_GetTimerAccuracy
    end interface
end module yepLibrary
