/*
 *                      Yeppp! library build framework
 *
 * This file is part of Yeppp! library infrastructure and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

package info.yeppp.Build;

public enum Architecture {
	X86,
	X64,
	IA64,
	ARM,
	MIPS,
	MIPS64,
	Power,
	Power64;

	boolean is64bit() {
		switch (this) {
			case X86:
				return false;
			case X64:
				return true;
			case IA64:
				return true;
			case ARM:
				return false;
			case MIPS:
				return false;
			case MIPS64:
				return true;
			case Power:
				return false;
			case Power64:
				return false;
			default:
				assert false;
				return false;
		}
	}
}
