/*
 *                      Yeppp! library build framework
 *
 * This file is part of Yeppp! library infrastructure and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

package info.yeppp.Build;

import java.util.Collection;
import java.util.List;

public interface Linker {
	public BuildMessages linkExecutable(String executablePath, Collection<String> objectPaths);

	public BuildMessages linkDynamicLibrary(String libraryPath, Collection<String> objectPaths, String specificationPath);

	public void setDebugEnabled(boolean debugEnabled);

	public boolean getDebugEnabled();

	public void setBinariesDirectory(String binariesDirectory);

	public String getBinariesDirectory();

	public void setObjectDirectory(String objectDirectory);

	public String getObjectDirectory();

	public boolean addStaticLibraryDependence(String libraryName);

	public boolean removeStaticLibraryDependence(String libraryName);

	public void clearStaticLibraryDependences();

    public boolean addDynamicLibraryDependence(String libraryName);
    
    public boolean removeDynamicLibraryDependence(String libraryName);

    public void clearDynamicLibraryDependences();

	public void setRuntimeLibraryUse(boolean runtimeLibraryUse);

	public boolean getRuntimeLibraryUse();

	public void addDefaultGlobalLibraryDirectories();

	public boolean addGlobalLibraryDirectory(String libraryDirectory);

	public boolean removeGlobalLibraryDirectory(String libraryDirectory);

	public void clearGlobalLibraryDirectories();

	public boolean addLibraryDirectory(String libraryDirectory);

	public boolean removeLibraryDirectory(String libraryDirectory);

	public void clearLibraryDirectories();

	public void clearAll();

	public Linker copy();

}
