/*
 *                      Yeppp! library build framework
 *
 * This file is part of Yeppp! library infrastructure and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

/*
 * Author:  andbin - http://andbin.altervista.org
 * License: Public Domain
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 */

package info.yeppp.Build.gui;

import com.sun.xml.internal.fastinfoset.algorithm.BuiltInEncodingAlgorithmFactory;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class GuiApp {
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new BuildVisualizationFrame().setVisible(true);
			}
		});
	}
}

class BorderedFilledColorIcon implements Icon {
	private int radius;
	private int margin;
	private Color borderColor;
	private Color fillColor;
	private int iconWidth;
	private int iconHeight;

	public BorderedFilledColorIcon(int radius, int margin, Color borderColor, Color fillColor) {
		this.radius = radius;
		this.margin = margin;
		this.borderColor = borderColor;
		this.fillColor = fillColor;

		iconWidth = radius + margin*2;
		iconHeight = radius + margin*2;
	}

	public int getIconWidth() {
		return iconWidth;
	}

	public int getIconHeight() {
		return iconHeight;
	}

	public void paintIcon(Component c, Graphics g, int x, int y) {
		Color oldColor = g.getColor();

		g.setColor(borderColor);
		g.fillOval(x+margin, y+margin, radius, radius);
		g.setColor(fillColor);
		g.fillOval(x+margin+1, y+margin+1, radius-2, radius-2);

		g.setColor(oldColor);
	}

	// This method is particularly useful in the renderer because lets to set
	// "on the fly" the fill color.
	public void setFillColor(Color fillColor) {
		this.fillColor = fillColor;
	}
}