set CXX=arm-linux-androideabi-g++
set CXXFLAGS=-nostdlib -mthumb-interwork -fPIC -ffunction-sections -Wno-psabi -march=armv7-a -mtune=cortex-a9 -mfloat-abi=softfp -mfpu=vfpv3-d16 -fno-exceptions -fno-unwind-tables -fomit-frame-pointer -fstrict-aliasing -funswitch-loops -Isources -Iheaders -Wa,--noexecstack -I%ANDROID_NDK_ROOT%/platforms/android-3/arch-arm/usr/include -DYEP_BUILD_LIBRARY -c
set CC=arm-linux-androideabi-gcc
set AS=arm-linux-androideabi-as
set ASFLAGS=--noexecstack
set CP=copy
set CPFLAGS=/Y
set RM=del
set RMFLAGS=/f /s /q

%RM% %RMFLAGS% "binaries/arm-linux-softeabi-androidv7a" >NUL 2>NUL
mkdir "binaries/arm-linux-softeabi-androidv7a/" >NUL 2>NUL
mkdir "binaries/arm-linux-softeabi-androidv7a/library/" >NUL 2>NUL
mkdir "binaries/arm-linux-softeabi-androidv7a/core/" >NUL 2>NUL
mkdir "binaries/arm-linux-softeabi-androidv7a/math/" >NUL 2>NUL

%CXX% -Os -mthumb %CXXFLAGS% sources/core/Add.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/core/Add.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/core/Add.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/core/Add.impl.o

%CXX% -Os -mthumb %CXXFLAGS% sources/core/Subtract.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/core/Subtract.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/core/Subtract.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/core/Subtract.impl.o

%CXX% -Os -mthumb %CXXFLAGS% sources/core/Multiply.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/core/Multiply.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/core/Multiply.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/core/Multiply.impl.o

%CXX% -Os -mthumb %CXXFLAGS% sources/core/MultiplyAdd.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/core/MultiplyAdd.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/core/MultiplyAdd.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/core/MultiplyAdd.impl.o

%CXX% -Os -mthumb %CXXFLAGS% sources/core/Negate.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/core/Negate.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/core/Negate.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/core/Negate.impl.o

%CXX% -Os -mthumb %CXXFLAGS% sources/core/DotProduct.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/core/DotProduct.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/core/DotProduct.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/core/DotProduct.impl.o

%CXX% -Os -mthumb %CXXFLAGS% sources/core/SumSquares.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/core/SumSquares.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/core/SumSquares.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/core/SumSquares.impl.o

%CXX% -Os -mthumb %CXXFLAGS% sources/math/Log.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/math/Log.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/math/Log.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/math/Log.impl.o

%CXX% -Os -mthumb %CXXFLAGS% sources/math/Exp.disp.cpp -o binaries/arm-linux-softeabi-androidv7a/math/Exp.disp.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/math/Exp.impl.cpp -o binaries/arm-linux-softeabi-androidv7a/math/Exp.impl.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/library/Init.cpp -o binaries/arm-linux-softeabi-androidv7a/library/Init.o

%CXX% -O3 -mthumb %CXXFLAGS% sources/library/Cpu.cpp -o binaries/arm-linux-softeabi-androidv7a/library/Cpu.o

%CXX% -Os -mthumb %CXXFLAGS% sources/library/Timer.cpp -o binaries/arm-linux-softeabi-androidv7a/library/Timer.o

%CXX% -Os -mthumb %CXXFLAGS% sources/library/Strings.cpp -o binaries/arm-linux-softeabi-androidv7a/library/Strings.o

%AS% %ASFLAGS% sources/library/Probe.arm.asm -o binaries/arm-linux-softeabi-androidv7a/library/Probe.arm.o

%CXX% -nostdlib -Wl,-soname,libyeppp.so -shared -Wl,--gc-sections -Wl,--version-script=sources/libyeppp.so.map --sysroot=%ANDROID_NDK_ROOT%/platforms/android-3/arch-arm -L../runtime/binaries/arm-linux-softeabi-androidv7a/ binaries/arm-linux-softeabi-androidv7a/core/Add.disp.o binaries/arm-linux-softeabi-androidv7a/core/Add.impl.o binaries/arm-linux-softeabi-androidv7a/core/Subtract.disp.o binaries/arm-linux-softeabi-androidv7a/core/Subtract.impl.o binaries/arm-linux-softeabi-androidv7a/core/Multiply.disp.o binaries/arm-linux-softeabi-androidv7a/core/Multiply.impl.o binaries/arm-linux-softeabi-androidv7a/core/MultiplyAdd.disp.o binaries/arm-linux-softeabi-androidv7a/core/MultiplyAdd.impl.o binaries/arm-linux-softeabi-androidv7a/core/Negate.disp.o binaries/arm-linux-softeabi-androidv7a/core/Negate.impl.o binaries/arm-linux-softeabi-androidv7a/core/DotProduct.disp.o binaries/arm-linux-softeabi-androidv7a/core/DotProduct.impl.o binaries/arm-linux-softeabi-androidv7a/core/SumSquares.disp.o binaries/arm-linux-softeabi-androidv7a/core/SumSquares.impl.o binaries/arm-linux-softeabi-androidv7a/math/Log.disp.o binaries/arm-linux-softeabi-androidv7a/math/Log.impl.o binaries/arm-linux-softeabi-androidv7a/math/Exp.disp.o binaries/arm-linux-softeabi-androidv7a/math/Exp.impl.o binaries/arm-linux-softeabi-androidv7a/library/Cpu.o binaries/arm-linux-softeabi-androidv7a/library/Timer.o binaries/arm-linux-softeabi-androidv7a/library/Init.o binaries/arm-linux-softeabi-androidv7a/library/Probe.arm.o binaries/arm-linux-softeabi-androidv7a/library/Strings.o -Wl,--no-undefined -Wl,-z,noexecstack -o binaries/arm-linux-softeabi-androidv7a/libyeppp.so -lyeprt

arm-linux-androideabi-strip binaries/arm-linux-softeabi-androidv7a/libyeppp.so
arm-linux-androideabi-strip -R .comment binaries/arm-linux-softeabi-androidv7a/libyeppp.so

%CP% %CPFLAGS% "binaries\arm-linux-softeabi-androidv7a\libyeppp.so" "..\binaries\android\armeabiv7a\libyeppp.so" >NUL 2>NUL
