#!/bin/bash
CXX=arm-linux-gnueabi-g++
CXXFLAGS="-nostdlib -mthumb-interwork -march=armv5t -mtune=arm1136j-s -mfloat-abi=soft -fPIC -ffunction-sections -Wno-psabi -fno-exceptions -fno-unwind-tables -fomit-frame-pointer -fstrict-aliasing -funswitch-loops -Isources -Iheaders -Wa,--noexecstack -DYEP_BUILD_LIBRARY -c"
AS=arm-linux-gnueabi-as
ASFLAGS="-Isources/arm --noexecstack"
CP=cp
CPFLAGS=-r
RM=rm
RMFLAGS="-rf"

$RM $RMFLAGS "binaries/arm-linux-softeabi-v5t" > /dev/null
mkdir "binaries/arm-linux-softeabi-v5t/"
mkdir "binaries/arm-linux-softeabi-v5t/library/"
mkdir "binaries/arm-linux-softeabi-v5t/core/"
mkdir "binaries/arm-linux-softeabi-v5t/math/"

$CXX -Os -mthumb $CXXFLAGS sources/core/Add.disp.cpp -o binaries/arm-linux-softeabi-v5t/core/Add.disp.o

$CXX -O3 -marm $CXXFLAGS sources/core/Add.impl.cpp -o binaries/arm-linux-softeabi-v5t/core/Add.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/Subtract.disp.cpp -o binaries/arm-linux-softeabi-v5t/core/Subtract.disp.o

$CXX -O3 -marm $CXXFLAGS sources/core/Subtract.impl.cpp -o binaries/arm-linux-softeabi-v5t/core/Subtract.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/Multiply.disp.cpp -o binaries/arm-linux-softeabi-v5t/core/Multiply.disp.o

$CXX -O3 -marm $CXXFLAGS sources/core/Multiply.impl.cpp -o binaries/arm-linux-softeabi-v5t/core/Multiply.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/MultiplyAdd.disp.cpp -o binaries/arm-linux-softeabi-v5t/core/MultiplyAdd.disp.o

$CXX -O3 -marm $CXXFLAGS sources/core/MultiplyAdd.impl.cpp -o binaries/arm-linux-softeabi-v5t/core/MultiplyAdd.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/Negate.disp.cpp -o binaries/arm-linux-softeabi-v5t/core/Negate.disp.o

$CXX -O3 -marm $CXXFLAGS sources/core/Negate.impl.cpp -o binaries/arm-linux-softeabi-v5t/core/Negate.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/DotProduct.disp.cpp -o binaries/arm-linux-softeabi-v5t/core/DotProduct.disp.o

$CXX -O3 -marm $CXXFLAGS sources/core/DotProduct.impl.cpp -o binaries/arm-linux-softeabi-v5t/core/DotProduct.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/SumSquares.disp.cpp -o binaries/arm-linux-softeabi-v5t/core/SumSquares.disp.o

$CXX -O3 -marm $CXXFLAGS sources/core/SumSquares.impl.cpp -o binaries/arm-linux-softeabi-v5t/core/SumSquares.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/math/Log.disp.cpp -o binaries/arm-linux-softeabi-v5t/math/Log.disp.o

$CXX -O3 -marm $CXXFLAGS sources/math/Log.impl.cpp -o binaries/arm-linux-softeabi-v5t/math/Log.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/math/Exp.disp.cpp -o binaries/arm-linux-softeabi-v5t/math/Exp.disp.o

$CXX -O3 -marm $CXXFLAGS sources/math/Exp.impl.cpp -o binaries/arm-linux-softeabi-v5t/math/Exp.impl.o

$CXX -O3 -mthumb $CXXFLAGS sources/library/Init.cpp -o binaries/arm-linux-softeabi-v5t/library/Init.o

$CXX -O3 -mthumb $CXXFLAGS sources/library/Cpu.cpp -o binaries/arm-linux-softeabi-v5t/library/Cpu.o

$CXX -Os -mthumb $CXXFLAGS sources/library/Timer.cpp -o binaries/arm-linux-softeabi-v5t/library/Timer.o

$CXX -Os -mthumb $CXXFLAGS sources/library/Strings.cpp -o binaries/arm-linux-softeabi-v5t/library/Strings.o

$AS $ASFLAGS sources/library/Probe.arm.asm -o binaries/arm-linux-softeabi-v5t/library/Probe.arm.o

$CXX -nostdlib -Wl,-soname,libyeppp.so -shared -Wl,--gc-sections -Wl,--version-script=sources/libyeppp.so.map binaries/arm-linux-softeabi-v5t/core/Add.disp.o binaries/arm-linux-softeabi-v5t/core/Add.impl.o binaries/arm-linux-softeabi-v5t/core/Subtract.disp.o binaries/arm-linux-softeabi-v5t/core/Subtract.impl.o binaries/arm-linux-softeabi-v5t/core/Multiply.disp.o binaries/arm-linux-softeabi-v5t/core/Multiply.impl.o binaries/arm-linux-softeabi-v5t/core/MultiplyAdd.disp.o binaries/arm-linux-softeabi-v5t/core/MultiplyAdd.impl.o binaries/arm-linux-softeabi-v5t/core/Negate.disp.o binaries/arm-linux-softeabi-v5t/core/Negate.impl.o binaries/arm-linux-softeabi-v5t/core/DotProduct.disp.o binaries/arm-linux-softeabi-v5t/core/DotProduct.impl.o binaries/arm-linux-softeabi-v5t/core/SumSquares.disp.o binaries/arm-linux-softeabi-v5t/core/SumSquares.impl.o binaries/arm-linux-softeabi-v5t/math/Log.disp.o binaries/arm-linux-softeabi-v5t/math/Log.impl.o binaries/arm-linux-softeabi-v5t/math/Exp.disp.o binaries/arm-linux-softeabi-v5t/math/Exp.impl.o binaries/arm-linux-softeabi-v5t/library/Cpu.o binaries/arm-linux-softeabi-v5t/library/Timer.o binaries/arm-linux-softeabi-v5t/library/Init.o binaries/arm-linux-softeabi-v5t/library/Strings.o binaries/arm-linux-softeabi-v5t/library/Probe.arm.o -Wl,--no-undefined -Wl,-z,noexecstack -L../runtime/binaries/arm-linux-softeabi-v5t -o binaries/arm-linux-softeabi-v5t/libyeppp.so -lyeprt

arm-linux-gnueabi-strip binaries/arm-linux-softeabi-v5t/libyeppp.so
arm-linux-gnueabi-strip -R .comment -R .note.gnu.build-id binaries/arm-linux-softeabi-v5t/libyeppp.so

$CP $CPFLAGS binaries/arm-linux-softeabi-v5t/libyeppp.so ../binaries/linux/armel/libyeppp.so
