/*
 *                      Yeppp! library implementation
 *
 * This file is part of Yeppp! library and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

#include <yepPredefines.h>
#include <yepTypes.h>
#pragma once

extern "C" YEP_PRIVATE_SYMBOL YepStatus _yepLibrary_InitCpuInfo();
extern "C" YEP_PRIVATE_SYMBOL FunctionPointer _yepLibrary_InitFunction(const FunctionDescriptor<YepStatus (*)()>* dispatchTable);

extern "C" YEP_PRIVATE_SYMBOL Yep64u _isaFeatures;
extern "C" YEP_PRIVATE_SYMBOL Yep64u _simdFeatures;
extern "C" YEP_PRIVATE_SYMBOL Yep64u _systemFeatures;
extern "C" YEP_PRIVATE_SYMBOL const YepCpuMicroarchitecture* _dispatchList;

#if defined(YEP_ARM_CPU) && defined(YEP_LINUX_OS)
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeV6K();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeV7MP();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeDiv();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeXScale();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeCnt32();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeVFP3();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeVFPd32();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeVFP3HP();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeVFP4();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeNeonHp();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeNeon2();
extern "C" YEP_PRIVATE_SYMBOL Yep64u _yepLibrary_ReadFPSID();
extern "C" YEP_PRIVATE_SYMBOL Yep64u _yepLibrary_ReadMVFR0();
extern "C" YEP_PRIVATE_SYMBOL Yep64u _yepLibrary_ReadWCID();
extern "C" YEP_PRIVATE_SYMBOL Yep64u _yepLibrary_ReadPMCCNTR();
extern "C" YEP_PRIVATE_SYMBOL Yep64u _yepLibrary_ReadPMCR();
#endif
#if defined(YEP_MIPS_CPU) && defined(YEP_LINUX_OS)
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbeR2();
extern "C" YEP_PRIVATE_SYMBOL Yep32u _yepLibrary_ProbePairedSingle();
#endif
