#!/bin/bash
CC=gcc
CCFLAGS="-nostdlib -marm -fPIC -ffunction-sections -Wno-psabi -march=armv5t -mtune=arm1136j-s -mfloat-abi=soft -fno-unwind-tables -O3 -fomit-frame-pointer -fno-strict-aliasing -funswitch-loops -Wa,--noexecstack -c"
AS=as
ASFLAGS="-Isources/arm --noexecstack"
RM=rm
RMFLAGS="-rf"

$RM $RMFLAGS "binaries/arm-linux-softeabi-v5t"
mkdir "binaries/arm-linux-softeabi-v5t/"

$AS $ASFLAGS sources/arm/gnu_thumb1_case.asm -o binaries/arm-linux-softeabi-v5t/gnu_thumb1_case.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/gnu_thumb1_case.o

$AS $ASFLAGS sources/arm/aeabi_ulcmp.asm -o binaries/arm-linux-softeabi-v5t/aeabi_ulcmp.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_ulcmp.o

$AS $ASFLAGS sources/arm/aeabi_llsl.asm -o binaries/arm-linux-softeabi-v5t/aeabi_llsl.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_llsl.o

$AS $ASFLAGS sources/arm/aeabi_lmul.asm -o binaries/arm-linux-softeabi-v5t/aeabi_lmul.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_lmul.o

$AS $ASFLAGS sources/arm/aeabi_fmul.asm -o binaries/arm-linux-softeabi-v5t/aeabi_fmul.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_fmul.o

$CC $CCFLAGS sources/arm/aeabi_dmul.c -o binaries/arm-linux-softeabi-v5t/aeabi_dmul.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_dmul.o

$CC $CCFLAGS sources/arm/aeabi_fadd.c -o binaries/arm-linux-softeabi-v5t/aeabi_fadd.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_fadd.o

$CC $CCFLAGS sources/arm/aeabi_dadd.c -o binaries/arm-linux-softeabi-v5t/aeabi_dadd.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_dadd.o

$CC $CCFLAGS sources/arm/aeabi_fsub.c -o binaries/arm-linux-softeabi-v5t/aeabi_fsub.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_fsub.o

$CC $CCFLAGS sources/arm/aeabi_dsub.c -o binaries/arm-linux-softeabi-v5t/aeabi_dsub.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_dsub.o

$AS $ASFLAGS sources/arm/aeabi_dcmpeq.asm -o binaries/arm-linux-softeabi-v5t/aeabi_dcmpeq.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_dcmpeq.o

$AS $ASFLAGS sources/arm/aeabi_dcmpge.asm -o binaries/arm-linux-softeabi-v5t/aeabi_dcmpge.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_dcmpge.o

$AS $ASFLAGS sources/arm/aeabi_dcmpgt.asm -o binaries/arm-linux-softeabi-v5t/aeabi_dcmpgt.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_dcmpgt.o

$AS $ASFLAGS sources/arm/aeabi_dcmple.asm -o binaries/arm-linux-softeabi-v5t/aeabi_dcmple.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_dcmple.o

$AS $ASFLAGS sources/arm/aeabi_dcmplt.asm -o binaries/arm-linux-softeabi-v5t/aeabi_dcmplt.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_dcmplt.o

$AS $ASFLAGS sources/arm/aeabi_i2d.asm -o binaries/arm-linux-softeabi-v5t/aeabi_i2d.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_i2d.o

$AS $ASFLAGS sources/arm/aeabi_ui2d.asm -o binaries/arm-linux-softeabi-v5t/aeabi_ui2d.o
strip --strip-unneeded binaries/arm-linux-softeabi-v5t/aeabi_ui2d.o

ar rcs binaries/arm-linux-softeabi-v5t/libyeprt.a binaries/arm-linux-softeabi-v5t/*.o
